---
title: ConvolverNode
slug: Web/API/ConvolverNode
tags:
  - API
  - ConvolverNode
  - Interface
  - Reference
  - Web Audio API
---
<p>{{APIRef("Web Audio API")}}</p>

<p>The <code>ConvolverNode</code> interface is an {{domxref("AudioNode")}} that performs a Linear Convolution on a given {{domxref("AudioBuffer")}}, often used to achieve a reverb effect. A <code>ConvolverNode</code> always has exactly one input and one output.</p>

<div class="note">
<p><strong>Note</strong>: For more information on the theory behind Linear Convolution, see the <a href="https://en.wikipedia.org/wiki/Convolution">Convolution article on Wikipedia</a>.</p>
</div>

<table class="properties">
	<tbody>
		<tr>
			<th scope="row">Number of inputs</th>
			<td><code>1</code></td>
		</tr>
		<tr>
			<th scope="row">Number of outputs</th>
			<td><code>1</code></td>
		</tr>
		<tr>
			<th scope="row">Channel count mode</th>
			<td><code>"clamped-max"</code></td>
		</tr>
		<tr>
			<th scope="row">Channel count</th>
			<td><code>1</code>, <code>2</code>, or <code>4</code></td>
		</tr>
		<tr>
			<th scope="row">Channel interpretation</th>
			<td><code>"speakers"</code></td>
		</tr>
	</tbody>
</table>

<h2 id="Constructor">Constructor</h2>

<dl>
	<dt>{{domxref("ConvolverNode.ConvolverNode()", "ConvolverNode()")}}</dt>
	<dd><span>Creates a new <code>ConvolverNode</code> object instance.</span></dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, </em><em>{{domxref("AudioNode")}}</em>.</p>

<dl>
	<dt>{{domxref("ConvolverNode.buffer")}}</dt>
	<dd><span>A mono, stereo, or 4-channel </span><em>{{domxref("AudioBuffer")}}</em><span> containing the (possibly multichannel) impulse response used by the <code>ConvolverNode</code> to create the reverb effect.</span></dd>
	<dt>{{domxref("ConvolverNode.normalize")}}</dt>
	<dd><span>A boolean that controls whether the impulse response from the buffer will be scaled by an equal-power normalization when the <code>buffer</code> attribute is set, or not.</span></dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>No specific method; inherits methods from its parent, </em><em>{{domxref("AudioNode")}}</em>.</p>

<h2 id="ConvolverNode_Example">ConvolverNode Example</h2>

<p>The following example shows basic usage of an AudioContext to create a convolver node.</p>

<div class="note">
<p><strong>Note</strong>: You will need to find an impulse response to complete the example below. See this <a href="https://codepen.io/DonKarlssonSan/pen/doVKRE">Codepen</a> for an applied example.</p>
</div>

<pre class="brush: js">let audioCtx = new window.AudioContext();

async function createReverb() {
    let convolver = audioCtx.createConvolver();

    // load impulse response from file
    let response     = await fetch("path/to/impulse-response.wav");
    let arraybuffer  = await response.arrayBuffer();
    convolver.buffer = await audioCtx.decodeAudioData(arraybuffer);

    return convolver;
}

...

let reverb = await createReverb();

// someOtherAudioNode -&gt; reverb -&gt; destination
someOtherAudioNode.connect(reverb);
reverb.connect(audioCtx.destination);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Web Audio API', '#ConvolverNode', 'ConvolverNode')}}</td>
			<td>{{Spec2('Web Audio API')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ConvolverNode")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
